package ims.headfinder;

import ims.data.IModel;
import ims.hotcoref.symbols.SymbolTable;
import ims.perceptron.Long2IntInterface;
import ims.trans.InstanceMapping;
import ims.trans.labelfilter.ILabelFilter;

public class Model implements IModel {
	private static final long serialVersionUID = 7764901685230626918L;

	public static final String ZIP_ENTRY = "_hfmodel";
	
	public final float[] parameters;
	public final Long2IntInterface l2i;
	public final SymbolTable symTab;
	public final InstanceMapping instanceMapping;
	public final ILabelFilter labels;
	
	public Model(float[] parameters, Long2IntInterface l2i, SymbolTable symTab,	InstanceMapping instanceMapping, ILabelFilter labels) {
		super();
		this.parameters = parameters;
		this.l2i = l2i;
		this.symTab = symTab;
		this.instanceMapping = instanceMapping;
		this.labels=labels;
	}

	@Override
	public float[] getParameters() {
		return parameters;
	}

}
