package ims.io;

import ims.data.Document;
import ims.data.ISentence;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.List;

public class DocumentWriter {
	
	private final BufferedWriter out;

	public DocumentWriter(File output) throws UnsupportedEncodingException, FileNotFoundException{
		this.out=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(output),"utf8"));
	}
	
	public void write(Document<?> d) throws IOException {
		int tokOffset=0;
		int sx=0;
		for(ISentence s:d.sents){
			s.insertTokenOffsetsInHeadAndIDCols(tokOffset);
			List<String> lines=s.getTabbedLineList();
			String sId=d.sIDs.get(sx++);
			String dId=d.dID;
			for(String line:lines){
				String o=line+"\t"+sId+"\t"+dId;
				out.write(o);
				out.newLine();
			}
			tokOffset+=s.getLength()-1;
		}
		out.newLine();
		out.flush();
	}

	public void close() throws IOException {
		out.close();
	}
	
}
