package ims.io;

import ims.data.ISentence;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.zip.GZIPOutputStream;

public class TabbedWriter implements SentenceWriter {
	
	private final BufferedWriter out;
	
	public TabbedWriter(File output) throws IOException{
		OutputStream os=new FileOutputStream(output);
		if(output.toString().endsWith(".gz"))
			os=new GZIPOutputStream(os);
		this.out=new BufferedWriter(new OutputStreamWriter(os,"utf8"));
	}

	public void write(ISentence s) throws IOException {
		String x=s.getTabbedToString();
		out.write(x);
		out.newLine();
		out.newLine();
		out.flush();
	}

	public void close() throws IOException {
		out.close();
	}

}
