package ims.perceptron;

import ims.trans.Options;

public class Long2IntFactory {

	public enum Long2IntImpl { Exact, Bohnet, Modulo, RBG, AB, AB2, ABFast }
	
	public static Long2IntInterface getLong2Int(Options options){
		return getLong2Int(options.l2iImpl,options.hashSize);
	}
	
	public static Long2IntInterface getLong2Int(Long2IntImpl impl,int size){
		switch(impl){
		case Bohnet: return new Long2Int(size);
		case Exact:  return new Long2IntExact(size);
		case Modulo: return new AbstractLong2IntHash.Long2IntModulo(size);
		case RBG:    return new AbstractLong2IntHash.Long2IntRBG(size);
		case AB:     return new AbstractLong2IntHash.Long2IntAB(size);
		case AB2:    return new AbstractLong2IntHash.Long2IntAB2(size);
		case ABFast: return new AbstractLong2IntHash.Long2IntABFast(size);
		default:     throw new Error("not implemented");
		
		}
	}
	
}
