package ims.tag.features;

import ims.hotcoref.symbols.TagSymbolTable;
import ims.tag.ITagContext;
import ims.tag.TagContext;
import ims.tag.TagInstance;

public class LocalFeatureSet extends AbstractFeatureSet{

	private static final long serialVersionUID = 7554096799843834866L;

	protected LocalFeatureSet(TagSymbolTable symTab) {
		super(symTab);
	}

	@Override
	public int extractLocalFeatures(int idx, TagInstance inst) {
		final int f=inst.forms[idx];
		final int fm1,fm2;
		final int fp1,fp2;
		if(idx-1>0){
			fm1=inst.forms[idx-1];
			if(idx-2>0){
				fm2=inst.forms[idx-2];
			} else {
				fm2=NONE;
			}
		} else {
			fm1=NONE;
			fm2=NONE;
		}
		
		if(idx+1<inst.forms.length){
			fp1=inst.forms[idx+1];
			if(idx+2<inst.forms.length){
				fp2=inst.forms[idx+2];
			} else {
				fp2=NONE;
			}
		} else {
			fp1=NONE;
			fp2=NONE;
		}
		
		int t=1; int m=0;
		//forms
		sink[m]=t; sink[m]<<=bF; sink[m]|=f;   ++m; ++t;
		sink[m]=t; sink[m]<<=bF; sink[m]|=fm1; ++m; ++t;
		sink[m]=t; sink[m]<<=bF; sink[m]|=fm2; ++m; ++t;
		sink[m]=t; sink[m]<<=bF; sink[m]|=fp1; ++m; ++t;
		sink[m]=t; sink[m]<<=bF; sink[m]|=fp2; ++m; ++t;
		
		//prefixes
		for(int l=1;l<inst.suffixes[idx].length;++l){
			sink[m]=t; sink[m]<<=bA; sink[m]|=inst.prefixes[idx][l]; ++m; ++t;
		}
		//suffixes
		for(int l=1;l<inst.suffixes[idx].length;++l){
			sink[m]=t; sink[m]<<=bA; sink[m]|=inst.suffixes[idx][l]; ++m; ++t;
		}
		
		//Spelling features
		sink[m]=t; sink[m]<<=2; sink[m]|=inst.containsDigit[idx]?1:0;     ++m; ++t;
		sink[m]=t; sink[m]<<=2; sink[m]|=inst.containsHyphen[idx]?1:0;    ++m; ++t;
		sink[m]=t; sink[m]<<=2; sink[m]|=inst.containsUppercase[idx]?1:0; ++m; ++t;
		
		return m;
	}

	@Override
	public int extractNonLocalFeatures(int idx, TagInstance inst, ITagContext context) {
		return 0;
	}

//	@Override
//	public double recoverFeaturesAndFillFV(TagInstance inst, TagContext context, int idx, int tag, FeatureScorer featureScorer, IFV<?> fv) {
//		int m=extractLocalFeatures(idx,inst);
//		ArrayFunctions.shiftAllLeftByBits(sink, bT, m);
//		for(int i=0;i<m;++i){
//			sink[i]|=tag;
//			int y=featureScorer.l2i.l2i(sink[i]);
//			fv.add(y);
//		}
//		double score=featureScorer.scoreFeatures(sink, m);
//		return score;
//	}

}
