package ims.trans;

import ims.data.Instance;
import ims.util.ArrayShuffler;
import ims.util.DBO;

import java.util.List;

public class StaticListInstanceCreator implements IInstanceCreator {

	private final List<Instance> instances;

	public StaticListInstanceCreator(List<Instance> instances){
		this.instances=instances;
		if(Options.shuffleStrategy.shuffleFirstIteration){
			DBO.println("Shuffling instances (pre-training)");
			new ArrayShuffler().shuffle(instances);
		}
	}
	
	@Override
	public List<Instance> getInstances() {
		return instances;
	}
	
}
