package ims.trans.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.TreeMap;

import ims.util.IOUtils;
import ims.util.MutableInt;
import ims.util.Util;

public class TRSeqNGrams {

	public static void main(String[] args) throws IOException{
		int n=3;
		if(args.length>0)
			n=Integer.parseInt(args[0]);
		--n;
		BufferedReader br=IOUtils.getSTDINBufferedReader();
		Map<String,MutableInt> m=new TreeMap<String,MutableInt>();
		String line;
		while((line=br.readLine())!=null)
			countNGrams(line,n,m);
		
		List<Entry<String,MutableInt>> l=MutableInt.getEntriesSortedByFrequencyDescending(m);
		int total=0;
		int maxLen=0;
		for(Entry<String,MutableInt> e:l){
			total+=e.getValue().getValue();
			maxLen=Math.max(maxLen, e.getKey().length());
		}
		
		String format="%-"+maxLen+"s    %-8d   (%5.2f%%)\n";
		
		for(Entry<String,MutableInt> e:l){
			double ratio=100.0*e.getValue().getValue()/total;
			System.out.printf(format,e.getKey(),e.getValue().getValue(),ratio);
		}
	}

	static void countNGrams(String line, int n, Map<String, MutableInt> m) {
		String[] trs=line.split(",");
		List<String> gram=new LinkedList<String>();
		for(int i=0;i<n;++i)
			gram.add("<BOS>");
		for(int i=0;i<trs.length;++i){
			gram.add(trs[i]);
			String ngram=Util.joinStrings(gram, " ");
			MutableInt.incrementMapValue(m, ngram);
			gram.remove(0);
		}
		for(int i=0;i<n;++i){
			gram.add("<EOS>");
			String ngram=Util.joinStrings(gram, " ");
			MutableInt.incrementMapValue(m, ngram);
			gram.remove(0);
		}
	}
	
}
