package ims.util;

import java.util.Arrays;

public class DisjointSetZeroToNRankPathComp extends DisjointSetZeroToN{

	private int[] rank;
	
	public DisjointSetZeroToNRankPathComp(int length) {
		super(length);
		rank=new int[length];
		Arrays.fill(rank, 0);
	}

	
	public int find(int i){
		if(parents[i]!=i)
			parents[i]=find(parents[i]);
		return parents[i];
	}
	
	public void union(int x,int y){
		int xRoot=find(x);
		int yRoot=find(y);
		if(xRoot==yRoot)
			return;
		if(rank[xRoot]<rank[yRoot]){
			parents[xRoot]=yRoot;
		} else if(rank[xRoot]>rank[yRoot]){
			parents[yRoot]=xRoot;
		} else {
			parents[yRoot]=xRoot;
			rank[xRoot]++;
		}
		subsetCount--;
	}
}
