package ims.util;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

public class MutableInt {
	int value;
	public MutableInt(){
		this(1);
	}
	public MutableInt(int value){
		this.value=value;
	}
	public void increment(){
		value++;
	}
	public int getValue(){
		return value;
	}
	public void setValue(int v){
		value=v;
	}
	public String toString(){
		return Integer.toString(value);
	} 
	
	public static <T> void incrementMapValue(Map<T,MutableInt> tm, T key){
		MutableInt mi=tm.get(key);
		if(mi==null){
			tm.put(key,new MutableInt(1));
		} else {
			mi.increment();
		}
	}
	
	public static <T> T getMostFrequent(Map<T,MutableInt> m){
		List<Entry<T,MutableInt>> l=new ArrayList<Entry<T,MutableInt>>(m.entrySet());
		Collections.sort(l, Collections.reverseOrder(MAP_ENTRY_COMPARATOR));
		return l.get(0).getKey();		
	}
	
	public static <T> List<Entry<T,MutableInt>> getEntriesSortedByFrequencyAscending(Map<T,MutableInt> tm){
		List<Entry<T,MutableInt>> l=new ArrayList<Entry<T,MutableInt>>(tm.entrySet());
		Collections.sort(l, MAP_ENTRY_COMPARATOR);
		return l;
	}
	
	public static <T> List<Entry<T,MutableInt>> getEntriesSortedByFrequencyDescending(Map<T,MutableInt> tm){
		List<Entry<T,MutableInt>> l=new ArrayList<Entry<T,MutableInt>>(tm.entrySet());
		Collections.sort(l, Collections.reverseOrder(MAP_ENTRY_COMPARATOR));
		return l;
	}
	
	public static <T> void printEntryList(Iterable<Entry<T,MutableInt>> iterable,int stringWidth,PrintStream out){
		for(Entry<T,MutableInt> e:iterable)
			out.printf("%-"+stringWidth+"s  %d\n", e.getKey().toString(),e.getValue().value);
	}

	
	static final Comparator<Entry<?,MutableInt>> MAP_ENTRY_COMPARATOR=new Comparator<Entry<?,MutableInt>>(){

		@Override
		public int compare(Entry<?, MutableInt> o1, Entry<?, MutableInt> o2) {
			return Integer.compare(o1.getValue().getValue(), o2.getValue().getValue());
		}
		
	};
}