package ims.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class SortSentencesByLength {

	public static void main(String[] args) throws Exception{
		BufferedReader reader=new BufferedReader(new InputStreamReader(System.in,"utf8"));
		List<List<String>> sentences=new ArrayList<List<String>>();
		List<String> sent=new ArrayList<String>();
		String line;
		while((line=reader.readLine())!=null){
			if(line.matches("^\\s*$")){ //end of sentence
				sentences.add(sent);
				sent=new ArrayList<String>();
			} else {
				sent.add(line);
			}
		}
		reader.close();
		
		//Sort
		Collections.sort(sentences,new Comparator<List<String>>(){
			@Override
			public int compare(List<String> o1, List<String> o2) {
				return o1.size()-o2.size();
			}});
		
		//write
		BufferedWriter writer=new BufferedWriter(new OutputStreamWriter(System.out,"utf8"));
		for(List<String> s:sentences){
			for(String l:s){
				writer.write(l);
				writer.newLine();
			}
			writer.newLine();
		}
		writer.close();

	}
}
